pragma Ada_2022;

with Ada.Text_IO;
with Ada.Calendar; use Ada.Calendar;
with Ada.Numerics.Float_Random;

procedure Main is
   Gen : Ada.Numerics.Float_Random.Generator;
   procedure Perform_Random_Duration_Processing is
   begin
      delay Duration (1.5 * Ada.Numerics.Float_Random.Random (Gen));
   end Perform_Random_Duration_Processing;

   task type T_Relative;
   task body T_Relative is
      N : Natural := 0;
   begin
      loop
         Perform_Random_Duration_Processing;
         Ada.Text_IO.Put_Line (N'Image & " Relative");
         N := N + 1;
         delay 1.0;
      end loop;
   end T_Relative;

   task type T_Absolute;
   task body T_Absolute is
      Next : Time := Clock;
      N : Natural := 0;
   begin
      loop
         Perform_Random_Duration_Processing;
         Ada.Text_IO.Put_Line (N'Image & " Absolute");
         N := N + 1;
         Next := Next + Duration (1.0);
         delay until Next;
      end loop;
   end T_Absolute;

   Relative : T_Relative;
   Absolute : T_Absolute;

   Start : constant Time := Clock;
begin
   loop
      Ada.Text_IO.Put_Line ("⏱️" & Natural'Image (Natural (Clock - Start)) & " seconds elapsed");
      delay 1.0;
   end loop;
end Main;
